VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "C_Cartographe"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public cMatrice As C_Matrice ' Classe mre
Public cGeographe As New C_Geographe ' Classe fille

Private cCases() As New C_Case
Public NbCasesX, NbCasesY As Long ' Dimensions en nombres de cases
Public NbCases As Long ' nombre total de cases

Private cLieux() As C_Lieu
Public NbLieux As Long
Private cIssues() As C_Issue
Public NbIssues As Long
Public ListeLieuxValides As Collection

Private ContourMurageAbsolu() As Segment
Private Type LieuxAdjacents
    cLieuA As C_Lieu
    cCasesA() As C_Case
    NbCasesA As Integer
End Type

' Paramtrage de la carte
Public NbLieuxMax As Long
Public NbSallesIsolees As Integer
Public PourcentageSalle As Integer
Public PourcentageCouloirPerpendiculaire As Integer
Public TailleSalleMin, TailleSalleMax, TailleCouloirMin, TailleCouloirMax As Integer
Public MaxRepetition, MaxChantiers As Long
Public PourcentageCulDeSacEnleves, PourcentageCulDeSacEnlevesFinal As Integer
Public InsistanceEnleverCulDeSac, InsistanceEnleverCulDeSacFinal As Integer
Public PourcentageSalleSalleAfficherPorte, PourcentageSalleCouloirAfficherPorte, PourcentageCouloirCouloirAfficherPorte As Integer
Public PourcentageSalleSalleJonction, PourcentageSalleCouloirJonction, PourcentageCouloirCouloirJonction As Integer
    
    
Public Function CreerCarte()
    Dim i, j As Long
    Dim cLieuOrigine, cLieuDestination As C_Lieu
    Dim cIssue As C_Issue
    Dim PourcentageSalleRetenu As Integer
    
    Set ListeLieuxValides = New Collection
    ReDim cIssues(0)
    ReDim cLieux(0)
    IncrementMot = 0
    NbLieux = 0
    NbIssues = 0
    
    
    Set cGeographe.cCartographe = Me
    Call cDatabase.ChargerNiveau(1, Me)
    ReDim cCases(NbCasesX, NbCasesY)
    Call InitialiserCases

    ' Cration de la (ou des) salle initiale
    PourcentageSalleRetenu = PourcentageSalle
    PourcentageSalle = 100 ' On force la construction de Salles uniquement (pas de couloirs)
    
    For i = 0 To NbSallesIsolees
        Call CreerLieuInitial
    Next
    
    PourcentageSalle = PourcentageSalleRetenu ' On rtabli le paramtre
    
    For j = 1 To MaxChantiers
        For i = 1 To MaxRepetition

            ' CHOISIR ALEATOIREMENT UN DES LIEUX DE LA CARTE (salle ou couloir)
            Set cLieuOrigine = ChoisirLieuAleatoire
            
            ' DETERMINER ALEATOIREMENT QUELLE PAROI DU LIEU D'ORIGINE SERVIRA DE DEPART POUR UN NOUVEAU LIEU DE DESTINATION
            Call cLieuOrigine.ChoisirParoiCouranteAleatoire
            
            ' DETERMINER ALEATOIREMENT QUEL CASE DE CETTE PAROI SERA L'ISSUE VERS UN NOUVEAU LIEU DE DESTINATION
            Call cLieuOrigine.ChoisirIssueCouranteAleatoireRelatif
            
            ' A PARTIR DES COORDONNEES DU LIEU, DETERMINER LES COORDONNEES ABSOLUES DE SON ISSUE COURANTE
            Call cLieuOrigine.IssueCouranteRelatifVersAbsolu
            
            ' CREER UN LIEU D'UN TYPE (salle, couloir) ET DETERMINER SA TAILLE (Width et Height)
            Set cLieuDestination = cGeographe.CreerLieu(cLieuOrigine)
            
            ' DETERMINER LA PAROI DU LIEU DE DESTINATION FAISANT FACE A LA PAROI DU LIEU D'ORIGINE, ET LA METTRE EN PAROI COURANTE
            cLieuDestination.ParoiCourante = cGeographe.ParoiSymetrique(cLieuOrigine.ParoiCourante)
            
            ' DETERMINER ALEATOIREMENT LA CASE QUI SERVIRA D'ISSUE SUR LA PAROI COURANTE DU LIEU DE DESTINATION
            Call cLieuDestination.ChoisirIssueCouranteAleatoireRelatif ' le lieu n'tant pas encore plac, on reste en relatif
            
            ' DETERMINER LE TYPE D'ISSUE (Porte, Ouverture libre) SELON LES TYPES DE LIEUX CONJOINTS (Salle, Couloir)
            Set cLieuDestination.cIssueCourante = cGeographe.IssueCouranteDeterminerType(cLieuOrigine, cLieuDestination)
            
            ' REGLER LA POSITION ABSOLUE DU LIEU DE DESTINATION SELON LA COINCIDENCE FORCEE DES ISSUES D'ORIGINE ET DE DESTINATION
            Set cLieuDestination = cGeographe.LieuDestinationVersAbsolu(cLieuOrigine, cLieuDestination)
                
            ' A PARTIR DES COORDONNEES DU LIEU, DETERMINER LES COORDONNEES ABSOLUES DE SON ISSUE COURANTE
            Call cLieuDestination.IssueCouranteRelatifVersAbsolu
            
            ' VERIFIER QUE LE LIEU NE SORT PAS DE LA MATRICE, ET N'EMPIETE PAS SUR UN AUTRE LIEU
            If LieuEstPlacable(cLieuDestination) = True Then
            
                ' LE LIEU EST AJOUTE AU TABLEAU DES LIEUX DU CARTOGRAPHE
                Call AjouterLieu(cLieuDestination)
        
                ' AJOUTER L'ISSUE AU TABLEAU DES ISSUES DU CARTOGRAPHES, AVEC LES INFORMATIONS DES ISSUES CONJOINTES
                Set cIssue = Me.AjouterIssue(cLieuOrigine, cLieuDestination)
                
                ' METTRE A JOUR L'ISSUE DANS LE TABLEAU D'ISSUES DU LIEU DE DESTINATION, AJOUTER DES INFORMATIONS DE L'ISSUE DU CARTOGRAPHE
                Set cLieuDestination = cGeographe.LieuAjouterIssue(cLieuDestination, cIssue)
                
                ' METTRE A JOUR L'ISSUE DANS LE TABLEAU D'ISSUES DU  LIEU D'ORIGINE, AJOUTER DES INFORMATIONS DE L'ISSUE DU CARTOGRAPHE
                Set cLieuOrigine = cGeographe.LieuAjouterIssue(cLieuOrigine, cIssue)
                
                ' LES CASES DU CARTOGRAPHE SONT REMPLIES AVEC DU SOL SUR LA SUPERFICIE DU LIEU DE DESTINATION
                Call Me.LieuBatirFond(cLieuDestination)
                
                ' LA CASE DU CARTOGRAPHE CORRESPONDANT A L'ISSUE EST REMPLIE
                Call Me.LieuBatirIssue(cLieuDestination) ' l'issue courante du lieu de destination est la rfrence
                        
    
            End If
            ' MsgBox InfoDebugCases
            If Me.NbLieux > Me.NbLieuxMax Then Exit For
        Next

        
        ' ANNULER LES COULOIRS N'AYANT QU'UNE SEULE ISSUE
        Call EnleverCulsDeSac


    Next
    
    ' ANNULER LES COULOIRS N'AYANT QU'UNE SEULE ISSUE, PASSAGE FINAL
    PourcentageCulDeSacEnleves = PourcentageCulDeSacEnlevesFinal
    Call EnleverCulsDeSac
  '      PourcentageSalleSalleAfficherPorte = 100
  '      PourcentageSalleCouloirAfficherPorte = 100
   '     PourcentageCouloirCouloirAfficherPorte = 100
    ' Placer des issues opportunes (un Lieu est adjacent  un autre et il n'a pas d'issue commune avec lui)
    Call LieuxAdjacentsCreerJonction

    ' BATIR LES CONTOURS DE MURAGE DES LIEUX
    Call LieuxBatirContours

   ' Call LancerDebogueur(Me)
End Function


Public Function CreerLieuInitial() ' A_FAIRE : si aucun lieu placable, scuriser l'application
    Dim cLieu As C_Lieu
    Dim i As Integer
    Set cLieu = cGeographe.CreerLieu()
    cLieu.Left = cFonctions.NombreAleatoire(TailleSalleMax + 1, NbCasesX - TailleSalleMax - 1)
    cLieu.Top = cFonctions.NombreAleatoire(TailleSalleMax + 1, NbCasesY - TailleSalleMax - 1)
    cLieu.InitialiserRelatif
    cLieu.InitialiserAbsolu
    For i = 1 To 100 ' On boucle au cas o le lieu aurait du mal  se placer
        If Me.LieuEstPlacable(cLieu) Then
           ' on l'ajoute au tableau des lieux
            Call AjouterLieu(cLieu, True)
            ' Remplissage du lieu avec du sol
            Call LieuBatirFond(cLieu)
            Exit For
        End If
    Next
End Function


Public Function AjouterIssue(ByVal cLieuOrigine As C_Lieu, ByVal cLieuDestination As C_Lieu) As C_Issue
    Dim cIssue As New C_Issue
    NbIssues = NbIssues + 1
    ReDim Preserve cIssues(NbIssues)
    With cIssue
        .EstEffacee = False
        .EstAttribuee = True
        .IndexGeneral = NbIssues - 1
        .Index = NbIssues - 1
        .IndexLieuOrigine = cLieuOrigine.Index
        .IndexLieuDestination = cLieuDestination.Index
        .X_Absolu = cLieuOrigine.cIssueCourante.X_Absolu
        .Y_Absolu = cLieuOrigine.cIssueCourante.Y_Absolu
        .ParoiLieuOrigine = cLieuOrigine.ParoiCourante
        .ParoiLieuDestination = cLieuDestination.ParoiCourante
        .AfficherPorte = cLieuDestination.cIssueCourante.AfficherPorte
        .EstUneJonction = cLieuDestination.cIssueCourante.EstUneJonction
    End With
    
    Set cIssues(NbIssues - 1) = cIssue
    Set AjouterIssue = cIssue
End Function


Public Function AjouterLieu(ByRef cLieu As C_Lieu, Optional booLieuInitial As Boolean) As C_Lieu
    NbLieux = NbLieux + 1
    ReDim Preserve cLieux(NbLieux)
    cLieu.Index = NbLieux - 1
    If booLieuInitial = True Then cLieu.IndexLieuIsole = cLieu.Index
    Set cLieux(NbLieux - 1) = cLieu
    ' ListeLieuxValides.Add Item:=cLieu, Key:=CStr(NbLieux - 1)
    ListeLieuxValides.Add cLieu, CStr(NbLieux - 1)
    Set AjouterLieu = cLieux(NbLieux - 1)
End Function


Public Function ChoisirLieuAleatoire() As C_Lieu
    ' On choisit un lieu qui n'est pas effac
    Dim IndexLieu As Integer
    Do
        IndexLieu = cFonctions.NombreAleatoire(0, ListeLieuxValides.Count - 1)
        Set ChoisirLieuAleatoire = cLieux(IndexLieu)
    Loop While ChoisirLieuAleatoire.EstEfface = True
End Function



' ---------------- PERMIS DE CONSTRUIRE --------------------------------------------------------------------------

Public Function LieuEstPlacable(cLieu As C_Lieu) As Boolean
    ' Retourner True si le lieu est Placable, False si impossible  placer

    ' Verifie que le lieu n'est pas hors matrice
    If LieuEstDansMatrice(cLieu) = False Then Exit Function
    ' Verifie que le lieu n'crase pas un autre lieu
    If LieuEstBatissable(cLieu) = False Then Exit Function
    
    LieuEstPlacable = True
End Function


Public Function LieuEstDansMatrice(cLieu As C_Lieu)
    ' On laisse obligatoirement une ligne de bordure sur la matrice
    If cLieu.Left < 2 Then Exit Function
    If cLieu.Left + cLieu.Width > Me.NbCasesX - 1 Then Exit Function
    If cLieu.Top < 2 Then Exit Function
    If cLieu.Top + cLieu.Height > Me.NbCasesY - 1 Then Exit Function
    LieuEstDansMatrice = True
End Function


Public Function LieuEstBatissable(cLieu As C_Lieu) As Boolean
    ' Vrifie qu'aucune des cases du lieu (contour du murage compris) ne soit pas sur un emplacement du type Sol
    Dim iX, iY As Integer
    For iY = cLieu.Top - 1 To cLieu.Top + cLieu.Height
        For iX = cLieu.Left - 1 To cLieu.Left + cLieu.Width
            If cCases(iX, iY).ExisteFond Then
                If cCases(iX, iY).cFond.Nom = "Sol" Then Exit Function
            End If
        Next
    Next
    LieuEstBatissable = True
End Function


' ---------------- BATISSEURS --------------------------------------------------------------------------

Public Function LieuBatirIssue(cLieu As C_Lieu)
    Dim cDecor As C_Decors
    Dim cIssue As C_Issue
    Set cDecor = cElement.DecorSelonNom("Porte")
    Set cIssue = cLieu.cIssueCourante
    With cCases(cIssue.X_Absolu, cIssue.Y_Absolu)
        If cIssue.AfficherPorte = True Then
            .ExisteDecor = True
            Set .cDecor = cDecor
        Else
            .ExisteDecor = False
        End If
        .X = cIssue.X_Absolu
        .Y = cIssue.Y_Absolu
        .EstUneIssue = True
        .EstUnLieu = False
        .EstUneJonction = cIssue.EstUneJonction
    '    .EstUnContour = True
        .IndexIssue = cIssue.IndexGeneral
    End With
End Function


Public Function LieuBatirFond(cLieu As C_Lieu)
    Dim iX, iY As Integer
    Dim cFond As C_Fond
    Set cFond = cElement.FondSelonNom("Sol")
    ' Remplissage du lieu avec du sol
    For iY = cLieu.Top To cLieu.Top + cLieu.Height - 1
        For iX = cLieu.Left To cLieu.Left + cLieu.Width - 1
            With cCases(iX, iY)
                .EstUnLieu = True
                .EstUneIssue = False
                .EstUnContour = False
                .ExisteFond = True
                .X = iX
                .Y = iY
                .IndexLieu = cLieu.Index
                Set .cFond = cFond
            End With
        Next
    Next
End Function


Public Function LieuxBatirContours()
    ' Fait en dernier au cas o l'on doit effacer des Lieux
    ' Les infos de l'issues suffisent donc pas besoin de la dessiner pour la reprer
    Dim i As Integer
    For i = 0 To NbLieux - 1
        If cLieux(i).EstEfface = False Then Call Me.LieuBatirContour(cLieux(i))
    Next
End Function


Public Function LieuBatirContour(cLieu As C_Lieu)
    Dim iX, iY, i As Integer
    Dim cFond As C_Fond
    Dim cFondSol As C_Fond
    Dim Contour() As Segment

    cLieu.gTabDevientContourMurageAbsolu
    Contour = gTab.Contour
    
    Set cFondSol = cElement.FondSelonNom("Sol")
    ' Contour du lieu avec du mur
    Set cFond = cElement.FondSelonNom("Mur")
    ' on dessine les quatres parois, segment par segment
    For i = 0 To 3 ' Les 4 orientations
        For iY = Contour(i).Depart.Y To Contour(i).Arrivee.Y Step Contour(i).Sens
            For iX = Contour(i).Depart.X To Contour(i).Arrivee.X Step Contour(i).Sens
                With cCases(iX, iY)
                    If .EstUneIssue = True Then
                        Set .cFond = cFondSol
                    Else
                        Set .cFond = cFond ' Mur
                    End If
                    .ExisteFond = True
                    .X = iX
                    .Y = iY
                    .EstUnContour = True
                    .EstUnLieu = False
                    .NbLieuxContour = .NbLieuxContour + 1
                End With
            Next
        Next
    Next
End Function


' ---------------- DEMOLISSEURS --------------------------------------------------------------------------

Public Function EnleverCulsDeSac()
    ' PourcentageCulDeSacEnleves
    Dim i, j As Long
    For j = 1 To InsistanceEnleverCulDeSacFinal
        For i = 0 To NbLieux - 1
            EnleverCulDeSac cLieux(i)
        Next
    Next
End Function


Public Function EnleverCulDeSac(ByRef cLieu As C_Lieu)
    With cLieu
        If .TypeLieu <> "Couloir" Then Exit Function
        If .EstEfface = True Then Exit Function
        If PourcentageCulDeSacEnleves < 100 Then
            If cFonctions.NombreAleatoire(1, 100) > PourcentageCulDeSacEnleves Then Exit Function
        End If
        If .NombreIssuesValides = 1 Then
            ' on efface le lieu et son issue
            Call LieuEffacerFond(cLieu)
            Call LieuEffacerIssue(cLieu)
            .InitialiserIssues
            .EstEfface = True
            ListeLieuxValides.Remove CStr(.Index)
        End If
    End With
End Function


Public Function LieuEffacerIssue(ByRef cLieu As C_Lieu)
    Dim cLieuAdjacent As C_Lieu
    Dim cIssue As C_Issue
    Dim IndexLieuAdjacent As Integer
    ' le lieu faisant paire pour l'issue doit galement avoir son issue retire
    With cLieu.cIssueCourante
        cCases(.X_Absolu, .Y_Absolu).ExisteDecor = False
        cCases(.X_Absolu, .Y_Absolu).EstUneIssue = False
        Set cCases(.X_Absolu, .Y_Absolu).cDecor = Nothing
        .EstEffacee = True
        .EstAttribuee = False
        cIssues(.IndexGeneral).EstEffacee = True
        cIssues(.IndexGeneral).EstAttribuee = False
        If cIssues(.IndexGeneral).IndexLieuOrigine = cLieu.Index Then
            IndexLieuAdjacent = cIssues(.IndexGeneral).IndexLieuDestination
        Else
            IndexLieuAdjacent = cIssues(.IndexGeneral).IndexLieuOrigine
        End If
        Set cLieuAdjacent = cLieux(IndexLieuAdjacent)
        Set cIssue = cLieuAdjacent.IssueSelonIndexGeneral(.IndexGeneral)
        cIssue.EstEffacee = True
        cIssue.EstAttribuee = False
    End With
End Function


Public Function LieuEffacerFond(ByRef cLieu As C_Lieu)
    Dim iX, iY As Integer
    For iY = cLieu.Top To cLieu.Top + cLieu.Height - 1
        For iX = cLieu.Left To cLieu.Left + cLieu.Width - 1
            With cCases(iX, iY)
                .EstUnLieu = False
                .ExisteFond = False
                Set .cFond = Nothing
            End With
        Next
    Next
End Function


' ---------------- JONCTIONS OPPORTUNES -----------------------------------------------

Public Function LieuxAdjacentsCreerJonction()
    Dim i As Integer
    Dim cLieu As C_Lieu
   ' For Each cLieu In ListeLieuxValides
   '     If cLieu.EstEfface = False Then Call LieuBatirIssuesJonction(cLieux(cLieu.Index))
  '  Next
    For i = 0 To NbLieux - 1
        If cLieux(i).EstEfface = False Then Call LieuBatirIssuesJonction(cLieux(i))
    Next
End Function


Public Function LieuBatirIssuesJonction(cLieu As C_Lieu)
    Dim cLieuxAdjacents() As LieuxAdjacents
    Dim NbLieuxAdjacents As Integer
    Dim i As Integer
    ReDim cLieuxAdjacents(0)
    
    Call LieuxAdjacentsRemplir(cLieuxAdjacents, NbLieuxAdjacents, cLieu)
    
    For i = 0 To NbLieuxAdjacents - 1
        ' Si test suivant pourcentage jonction Ok on passe :
        If cGeographe.TesterPourcentageCreationJonction(cLieu, cLieuxAdjacents(i).cLieuA) = True Then
            ' Batir l'issue (si possible - cas des issues imposes)
            Call LieuxAdjacentsBatirIssue(cLieu, cLieuxAdjacents(i))
        End If
    Next
End Function


Private Function LieuxAdjacentsBatirIssue(cLieu As C_Lieu, cLieuAdjacent As LieuxAdjacents)
    Dim cCase As New C_Case
    Dim cIssue As New C_Issue
    Set cCase = cLieuAdjacent.cCasesA(cFonctions.NombreAleatoire(0, cLieuAdjacent.NbCasesA - 1))
    
    Call cLieuAdjacent.cLieuA.DeterminerIssueCouranteAbsolu(cCase)
    Call cLieu.DeterminerIssueCouranteAbsolu(cCase)
    Set cLieuAdjacent.cLieuA.cIssueCourante = cGeographe.IssueCouranteDeterminerType(cLieu, cLieuAdjacent.cLieuA)
    cLieuAdjacent.cLieuA.cIssueCourante.EstUneJonction = True
    
    Set cIssue = Me.AjouterIssue(cLieu, cLieuAdjacent.cLieuA)
    Set cLieuAdjacent.cLieuA = cGeographe.LieuAjouterIssue(cLieuAdjacent.cLieuA, cIssue)
    Call cGeographe.LieuAjouterIssue(cLieu, cIssue)
    
    Call Me.LieuBatirIssue(cLieuAdjacent.cLieuA)
End Function


Private Function LieuxAdjacentsRemplir(ByRef cLieuxAdjacents() As LieuxAdjacents, ByRef NbLieuxAdjacents As Integer, cLieu As C_Lieu)
    ' Dtecte les lieux adjacents
    Dim iX, iY As Integer
    
    ' NORD
    iY = cLieu.Top - 2
    For iX = cLieu.Left To cLieu.Left + cLieu.Width - 1
        Call LieuAdjacentAjoutConditionnel(cLieuxAdjacents, NbLieuxAdjacents, cLieu, cCases(iX, iY), cCases(iX, iY + 1))
    Next
    
    ' SUD
    iY = cLieu.Top + cLieu.Height + 1
    For iX = cLieu.Left To cLieu.Left + cLieu.Width - 1
        Call LieuAdjacentAjoutConditionnel(cLieuxAdjacents, NbLieuxAdjacents, cLieu, cCases(iX, iY), cCases(iX, iY - 1))
    Next
    
    ' OUEST
    iX = cLieu.Left - 2
    For iY = cLieu.Top To cLieu.Top + cLieu.Height - 1
        Call LieuAdjacentAjoutConditionnel(cLieuxAdjacents, NbLieuxAdjacents, cLieu, cCases(iX, iY), cCases(iX + 1, iY))
    Next
    
    ' EST
    iX = cLieu.Left + cLieu.Width + 1
    For iY = cLieu.Top To cLieu.Top + cLieu.Height - 1
        Call LieuAdjacentAjoutConditionnel(cLieuxAdjacents, NbLieuxAdjacents, cLieu, cCases(iX, iY), cCases(iX - 1, iY))
    Next
End Function


Private Function LieuAdjacentAjoutConditionnel(ByRef cLieuxAdjacents() As LieuxAdjacents, ByRef NbLieuxAdjacents As Integer, cLieu As C_Lieu, cCase As C_Case, cCaseMurage As C_Case)
    If cCase.EstUnLieu = False Then Exit Function
    If cCase.EstUneIssue = True Then Exit Function
    If cLieux(cCase.IndexLieu).EstEfface = True Then Exit Function
    If cCase.ExisteFond = False Then Exit Function
    If cLieu.IssueCommuneExiste(cCase.IndexIssue) = True Then Exit Function ' A Garder ?
    If cLieu.LieuxOntIssueEnCommun(cLieux(cCase.IndexLieu).IssuesValidesEnChaineSeparateurEspace) = True Then Exit Function
    If LieuAdjacentEstNouveau(cLieuxAdjacents, NbLieuxAdjacents, cCase.IndexLieu) = True Then
        NbLieuxAdjacents = NbLieuxAdjacents + 1
        ReDim Preserve cLieuxAdjacents(NbLieuxAdjacents)
        Set cLieuxAdjacents(NbLieuxAdjacents - 1).cLieuA = cLieux(cCase.IndexLieu)
        ReDim cLieuxAdjacents(NbLieuxAdjacents - 1).cCasesA(0)
    End If
    ' On retient la case comme tant une case de frontire
    With cLieuxAdjacents(NbLieuxAdjacents - 1)
        .NbCasesA = .NbCasesA + 1
        ReDim Preserve .cCasesA(.NbCasesA)
        Set .cCasesA(.NbCasesA - 1) = cCaseMurage
        cCaseMurage.X = cCaseMurage.X
        cCaseMurage.Y = cCaseMurage.Y
    End With
End Function


Private Function LieuAdjacentEstNouveau(cLieuxAdjacents() As LieuxAdjacents, NbLieuxAdjacents, IndexLieu As Integer) As Boolean
    Dim i As Integer
    For i = 0 To NbLieuxAdjacents - 1
        If IndexLieu = cLieuxAdjacents(i).cLieuA.Index Then Exit Function
    Next
    LieuAdjacentEstNouveau = True
End Function

' ------------------------------------------------------------------------------------------

Private Function InitialiserCases()
    Dim X, Y As Long
    Dim s As String ' A_FAIRE : mettre l'initialisation dans la case !
    For Y = 0 To Me.NbCasesY - 1
        For X = 0 To Me.NbCasesX - 1
            With cCases(X, Y)
                .X = X
                .Y = Y
                .ExisteFond = False
                .ExisteDecor = False
                .EstUnContour = False
                .EstUneIssue = False
                .EstUneJonction = False
                .EstFranchissable = False
                .EstUnLieu = False
                .NbLieuxContour = 0
                .EstVisitee = False
                .DoitEtreEteinte = False
            End With
        Next
    Next
End Function


Public Function PlacerJoueur()
    Dim EstPlace As Boolean
    Dim X, Y As Long
    Do While EstPlace = False
        X = cFonctions.NombreAleatoire(2, Me.NbCasesX - 2)
        Y = cFonctions.NombreAleatoire(2, Me.NbCasesY - 2)
        If cCases(X, Y).EstUnLieu = True And cCases(X, Y).ExisteIndividu = False Then EstPlace = True
    Loop
    cJoueur.X = X
    cJoueur.Y = Y
    cCases(X, Y).ExisteIndividu = True
    cCases(X, Y).indexIndividu = cJoueur.Index
End Function


Public Function PlacerIndividu(ByVal indexIndividu As Integer)
    Dim EstPlace As Boolean
    Dim X, Y As Long
    Do While EstPlace = False ' A_FAIRE, mettre un nombre d'itration maximum (si plus d'individu que de places disponible
        ' Mieu mettre un boolen "limite atteinte"
        X = cFonctions.NombreAleatoire(2, Me.NbCasesX - 2)
        Y = cFonctions.NombreAleatoire(2, Me.NbCasesY - 2)
        If cCases(X, Y).EstUnLieu = True And cCases(X, Y).ExisteIndividu = False Then EstPlace = True
    Loop
    cIndividus(indexIndividu).X = X
    cIndividus(indexIndividu).Y = Y
    cCases(X, Y).ExisteIndividu = True
    cCases(X, Y).indexIndividu = indexIndividu
End Function


' ------------------------------------------------------------------------------------------

Function InfoDebugCases() As String
    Dim X, Y As Long
    Dim s As String
    For Y = 0 To Me.NbCasesY - 1
        For X = 0 To Me.NbCasesX - 1
            s = s & cCases(X, Y).InfosDebug
        Next
    Next
    InfoDebugCases = s
End Function

Function InfoDebugIssues() As String
    Dim i As Long
    Dim s As String
    For i = 0 To NbIssues - 1
        s = s & cIssues(i).InfosDebug
    Next
    InfoDebugIssues = s
End Function

Function InfoDebugLieux() As String
    Dim i As Long
    Dim s As String
    For i = 0 To NbLieux - 1
        s = s & cLieux(i).InfosDebug
    Next
    InfoDebugLieux = s
End Function

' ---------------- TRANSMISSION DE TABLEAUX -----------------------------------------------

Public Function gTabDevientCases()
    gTab.cCases = cCases
End Function

Public Function gTabAffecteCases()
    cCases = gTab.cCases
End Function


' ------------------------------------------------------------------------------------------

