VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "C_Geographe"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Contient toutes les fonctions utile au C_Cartographe du moment qu'elles n'utilisent pas ses tableaux
Public cCartographe As C_Cartographe


Public Function CreerLieu(Optional ByVal cLieuOrigine As C_Lieu) As C_Lieu
    Dim cLieu As New C_Lieu
    On Error Resume Next ' Sert  grer le fait qu'un paramtre optionel absent fait planter
    cLieu.IndexLieuIsole = cLieuOrigine.IndexLieuIsole

    Set cLieu.cCartographe = cCartographe
    If cCartographe.PourcentageSalle >= 100 Or cFonctions.NombreAleatoire(1, 100) <= cCartographe.PourcentageSalle Then
        cLieu.TypeLieu = "Salle"
        cLieu.Height = cFonctions.NombreAleatoire(cCartographe.TailleSalleMin, cCartographe.TailleSalleMax)
        cLieu.Width = cFonctions.NombreAleatoire(cCartographe.TailleSalleMin, cCartographe.TailleSalleMax)
    Else
        cLieu.TypeLieu = "Couloir"
        cLieu.Orientation = CouloirTrouverOrientation(cLieuOrigine)

        If cLieu.Orientation = NORD Or cLieu.Orientation = SUD Then
            cLieu.Height = cFonctions.NombreAleatoire(cCartographe.TailleCouloirMin, cCartographe.TailleCouloirMax)
            cLieu.Width = 1
        Else
            cLieu.Height = 1
            cLieu.Width = cFonctions.NombreAleatoire(cCartographe.TailleCouloirMin, cCartographe.TailleCouloirMax)
        End If
    End If
    Call cLieu.InitialiserRelatif
    Set CreerLieu = cLieu

End Function


Public Function LieuAjouterIssue(ByVal cLieu As C_Lieu, ByVal cIssue As C_Issue) As C_Lieu
    With cLieu.cIssueCourante
        .IndexGeneral = cIssue.IndexGeneral
        .EstAttribuee = True
        .AfficherPorte = cIssue.AfficherPorte
        .EstEffacee = cIssue.EstEffacee
        .EstAttribuee = cIssue.EstAttribuee
        .X_Absolu = cIssue.X_Absolu
        .Y_Absolu = cIssue.Y_Absolu
        .AfficherPorte = cIssue.AfficherPorte
        .EstUneJonction = cIssue.EstUneJonction
    End With
    Call cLieu.AjouterIssue(cLieu.cIssueCourante)
    Set LieuAjouterIssue = cLieu
End Function


Public Function LieuDestinationVersAbsolu(ByVal cLieuOrigine As C_Lieu, ByVal cLieuDestination As C_Lieu) As C_Lieu
    ' L'issue des deux Lieux doit coincider, ceci fait, cela nous donne les coordonnes absolues du nouveau lieu
    ' L'issue sera mise  jour en "absolu"
    With cLieuDestination
        .Left = cLieuOrigine.cIssueCourante.X_Absolu - .cIssueCourante.X_Relatif
        .Top = cLieuOrigine.cIssueCourante.Y_Absolu - .cIssueCourante.Y_Relatif
        Call .InitialiserAbsolu
    End With
    Set LieuDestinationVersAbsolu = cLieuDestination
End Function


Public Function IssueCouranteDeterminerType(ByVal cLieuOrigine As C_Lieu, ByVal cLieuDestination As C_Lieu) As C_Issue
    ' Dtermine le type d'issue (porte, ou autre)
    cLieuDestination.cIssueCourante.AfficherPorte = AfficherPorteTester(cLieuOrigine, cLieuDestination)
    Set IssueCouranteDeterminerType = cLieuDestination.cIssueCourante
End Function


Public Function AfficherPorteTester(ByVal cLieuOrigine As C_Lieu, ByVal cLieuDestination As C_Lieu) As Boolean
    AfficherPorteTester = True
    If cLieuOrigine.TypeLieu = "Salle" And cLieuDestination.TypeLieu = "Salle" Then
        If cCartographe.PourcentageSalleSalleAfficherPorte >= 100 Then Exit Function
        If cFonctions.NombreAleatoire(1, 100) <= cCartographe.PourcentageSalleSalleAfficherPorte Then Exit Function
    End If
    If (cLieuOrigine.TypeLieu = "Salle" And cLieuDestination.TypeLieu = "Couloir") Or (cLieuOrigine.TypeLieu = "Couloir" And cLieuDestination.TypeLieu = "Salle") Then
        If cCartographe.PourcentageSalleCouloirAfficherPorte >= 100 Then Exit Function
        If cFonctions.NombreAleatoire(1, 100) <= cCartographe.PourcentageSalleCouloirAfficherPorte Then Exit Function
    End If
    If cLieuOrigine.TypeLieu = "Couloir" And cLieuDestination.TypeLieu = "Couloir" Then
        If cCartographe.PourcentageCouloirCouloirAfficherPorte >= 100 Then Exit Function
        If cFonctions.NombreAleatoire(1, 100) <= cCartographe.PourcentageCouloirCouloirAfficherPorte Then Exit Function
    End If
    AfficherPorteTester = False
End Function


Public Function ParoiSymetrique(Paroi As ORIENTATIONS) As ORIENTATIONS
    If Paroi = EST Then ParoiSymetrique = OUEST
    If Paroi = NORD Then ParoiSymetrique = SUD
    If Paroi = OUEST Then ParoiSymetrique = EST
    If Paroi = SUD Then ParoiSymetrique = NORD
End Function


Public Function CouloirTrouverOrientation(Optional ByVal cLieu As C_Lieu) As ORIENTATIONS
    Dim Orientation As ORIENTATIONS
    If cCartographe.PourcentageCouloirPerpendiculaire < 100 Then
        If cFonctions.NombreAleatoire(1, 100) <= cCartographe.PourcentageCouloirPerpendiculaire Then
            CouloirTrouverOrientation = cFonctions.NombreAleatoire(0, 3)
            Exit Function
        End If
    End If
    If Not (IsEmpty(cLieu) Or IsMissing(cLieu)) Then
        If cLieu.TypeLieu = "Salle" Then
            CouloirTrouverOrientation = cLieu.ParoiCourante
        End If
        If cLieu.TypeLieu = "Couloir" Then
            CouloirTrouverOrientation = cLieu.ParoiCourante
            If cLieu.Orientation = NORD Or cLieu.Orientation = SUD Then
                If cLieu.ParoiCourante = NORD Or cLieu.ParoiCourante = SUD Then CouloirTrouverOrientation = OrientationAleatoireDesirable(ParoiSymetrique(cLieu.ParoiCourante))
            Else
                If cLieu.ParoiCourante = EST Or cLieu.ParoiCourante = OUEST Then CouloirTrouverOrientation = OrientationAleatoireDesirable(ParoiSymetrique(cLieu.ParoiCourante))
            End If
        End If
    End If
End Function


Public Function OrientationAleatoireDesirable(OrientationIndesirable As ORIENTATIONS) As ORIENTATIONS
    Do
        OrientationAleatoireDesirable = cFonctions.NombreAleatoire(0, 3)
    Loop While OrientationAleatoireDesirable = OrientationIndesirable
End Function


Public Function TesterPourcentageCreationJonction(cLieuOrigine As C_Lieu, cLieuDestination As C_Lieu) As Boolean
    TesterPourcentageCreationJonction = True
    ' (pour l'instant) on essaie toujours de joindre des portions isoles de la map
    If cLieuOrigine.IndexLieuIsole <> cLieuDestination.IndexLieuIsole Then Exit Function
    If cLieuOrigine.TypeLieu = "Salle" And cLieuDestination.TypeLieu = "Salle" Then
        If cCartographe.PourcentageSalleSalleJonction >= 100 Then Exit Function
        If cFonctions.NombreAleatoire(1, 100) <= cCartographe.PourcentageSalleSalleJonction Then Exit Function
    End If
    If (cLieuOrigine.TypeLieu = "Salle" And cLieuDestination.TypeLieu = "Couloir") Or (cLieuOrigine.TypeLieu = "Couloir" And cLieuDestination.TypeLieu = "Salle") Then
        If cCartographe.PourcentageSalleCouloirJonction >= 100 Then Exit Function
        If cFonctions.NombreAleatoire(1, 100) <= cCartographe.PourcentageSalleCouloirJonction Then Exit Function
    End If
    If cLieuOrigine.TypeLieu = "Couloir" And cLieuDestination.TypeLieu = "Couloir" Then
        If cCartographe.PourcentageCouloirCouloirJonction >= 100 Then Exit Function
        If cFonctions.NombreAleatoire(1, 100) <= cCartographe.PourcentageCouloirCouloirJonction Then Exit Function
    End If
    TesterPourcentageCreationJonction = False
End Function
