VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "C_Lieu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Public TypeLieu As String
Public Index As Integer ' Index du lieu dans un tableau de lieu du cartographe
Public Height, Width As Integer ' dimension de l'intrieur du lieu
Public Top, Left As Integer ' Coordonnes absolues de l'intrieur du lieu
Public IndexLieuIsole As Integer ' Lieu ayant servi  batir ce lieu de fil en aiguille

' Contient les coordonnes des points d'intersection des lignes de contour
Private ContourAbsolu() As Segment ' contour avec coordonnes absolues de l'intrieur du lieu
Private ContourMurageAbsolu() As Segment ' contour avec coordonnes absolues du murage entourant du lieu
Private ContourRelatif() As Segment ' contour avec coordonnes relatives de l'intrieur du lieu
Private ContourMurageRelatif() As Segment ' contour avec coordonnes relatives du murage entourant du lieu
Private cIssues() As C_Issue ' Contient une rfrence  toutes les issues du Lieu (attribues ou non)
Public NbIssues As Integer

Public Orientation As ORIENTATIONS
Public ParoiCourante As ORIENTATIONS ' Paroi servant  raliser un travail en cours
Public cIssueCourante As C_Issue ' issue servant  raliser un travail en cours
Public NbParois As Integer ' nombre de parois du lieu (4 pour un rectangle)

Public EstEfface As Boolean

Public cCartographe As C_Cartographe ' cartographe utilis par le lieu!


Public Function InfosDebug() As String
    Dim s As String
    s = s & "LIEU -  Index : " & Index & "     " & "TypeLieu : " & TypeLieu & "     " & "EstEfface : " & EstEfface & vbCrLf
    s = s & "Top : " & Top & "     " & "Left : " & Left & "     " & "Width : " & Width & "     " & "Height : " & Height & vbCrLf
    s = s & "NbIssues : " & NbIssues & vbCrLf & vbCrLf
    Dim i As Integer
    For i = 0 To NbIssues - 1
        s = s & cIssues(i).InfosDebug & vbCrLf
    Next
    InfosDebug = s & vbCrLf
End Function


Public Function InitialiserRelatif()
    InitialiserIssues
    ' Pour l'instant, on se limite  des pices rectangulaires
     ContourRelatif = DefinirContourRectangulaire(0, 0, Width, Height)
     ContourMurageRelatif = DefinirContourRectangulaire(0 - 1, 0 - 1, Width + 2, Height + 2)
End Function


Public Function InitialiserAbsolu()
     ContourAbsolu = DefinirContourRectangulaire(Left, Top, Width, Height)
     ContourMurageAbsolu = DefinirContourRectangulaire(Left - 1, Top - 1, Width + 2, Height + 2)
End Function


Public Function InitialiserIssues()
    NbIssues = 0 ' pour des issues impose, nombre diffrent
    ReDim cIssues(NbIssues)
End Function


Public Function AjouterIssue(cIssue As C_Issue)
    NbIssues = NbIssues + 1
    ReDim Preserve cIssues(NbIssues)
    cIssue.Index = NbIssues - 1
    cIssue.IndexLieu = Me.Index
    Set cIssues(NbIssues - 1) = cIssue
End Function


Public Function NombreIssuesValides() As Integer
    Dim i, IndexIssueCourante As Integer
    For i = 0 To NbIssues - 1
        If cIssues(i).EstEffacee = False And cIssues(i).EstAttribuee = True Then
            NombreIssuesValides = NombreIssuesValides + 1
            IndexIssueCourante = i
        End If
    Next
    If NombreIssuesValides = 1 Then Set cIssueCourante = cIssues(IndexIssueCourante)
End Function


Function IssueSelonIndexGeneral(IndexGeneral As Integer) As C_Issue
    Dim i As Integer
    For i = 0 To NbIssues - 1
        If cIssues(i).IndexGeneral = IndexGeneral Then Set IssueSelonIndexGeneral = cIssues(i)
    Next
End Function

Private Function DefinirContourRectangulaire(ByVal Left As Integer, ByVal Top As Integer, ByVal Width As Integer, ByVal Height As Integer) As Segment()
    Dim Contour(4) As Segment
    Dim Paroi As ORIENTATIONS
    ' Le contour est calcul avec un ordre de cheminement dans le sens des aiguilles d'une montre
    
    Paroi = NORD
    Contour(Paroi).Depart.X = Left
    Contour(Paroi).Depart.Y = Top
    Contour(Paroi).Arrivee.X = Left + Width - 1
    Contour(Paroi).Arrivee.Y = Top
    Contour(Paroi).Paroi = Paroi
    Contour(Paroi).Sens = 1
    
    Paroi = EST
    Contour(Paroi).Depart.X = Left + Width - 1
    Contour(Paroi).Depart.Y = Top
    Contour(Paroi).Arrivee.X = Left + Width - 1
    Contour(Paroi).Arrivee.Y = Top + Height - 1
    Contour(Paroi).Paroi = Paroi
    Contour(Paroi).Sens = 1

    Paroi = SUD
    Contour(Paroi).Depart.X = Left + Width - 1
    Contour(Paroi).Depart.Y = Top + Height - 1
    Contour(Paroi).Arrivee.X = Left
    Contour(Paroi).Arrivee.Y = Top + Height - 1
    Contour(Paroi).Paroi = Paroi
    Contour(Paroi).Sens = -1
    
    Paroi = OUEST
    Contour(Paroi).Depart.X = Left
    Contour(Paroi).Depart.Y = Top + Height - 1
    Contour(Paroi).Arrivee.X = Left
    Contour(Paroi).Arrivee.Y = Top
    Contour(Paroi).Paroi = Paroi
    Contour(Paroi).Sens = -1
    ' On fait le tour du rectangle, les coordonnes d'arrives OUEST sont les mmes que celles de dpart NORD
    
      DefinirContourRectangulaire = Contour
End Function


Public Function ChoisirParoiCouranteAleatoire()
    ParoiCourante = cFonctions.NombreAleatoire(0, 3)
End Function


Public Function ChoisirIssueCouranteAleatoireRelatif()
    ' Choisi une des cases situes sur le segment de Murage de la paroi (en vitant les coins)
    Dim CoordIssue As Coord
    Dim cIssue As New C_Issue
    With ContourMurageRelatif(ParoiCourante)
        Do
            CoordIssue.X = cFonctions.NombreAleatoire(.Depart.X, .Arrivee.X)
            CoordIssue.Y = cFonctions.NombreAleatoire(.Depart.Y, .Arrivee.Y)
        Loop While (CoordIssue.X = .Depart.X And CoordIssue.Y = .Depart.Y) Or (CoordIssue.X = .Arrivee.X And CoordIssue.Y = .Arrivee.Y)
    End With
    cIssue.X_Relatif = CoordIssue.X
    cIssue.Y_Relatif = CoordIssue.Y
    cIssue.Paroi = ParoiCourante
    cIssue.IndexLieu = Me.Index

    Set cIssueCourante = cIssue
End Function


Public Function DeterminerIssueCouranteAbsolu(cCase As C_Case)
    ' A partir de coordonnes absolues donnes, renseigne l'issue courante et les coordonnes relatives
    cIssueCourante.X_Absolu = cCase.X
    cIssueCourante.Y_Absolu = cCase.Y
    ' A_FAIRE : renseigner la paroi
'    cIssue.Paroi = ParoiCourante
    cIssueCourante.IndexLieu = Me.Index
    Call IssueCouranteAbsoluVersRelatif
End Function


Public Function IssueCommuneExiste(IndexGeneralIssue As Integer) As Boolean
    Dim i As Integer
    IssueCommuneExiste = True
    For i = 0 To NbIssues - 1
        If cIssues(i).EstAttribuee = True And cIssues(i).EstEffacee = False Then
            If cIssues(i).IndexGeneral = IndexGeneralIssue Then Exit Function
        End If
    Next
    IssueCommuneExiste = False
End Function


Public Function LieuxOntIssueEnCommun(strIssuesValides) As Boolean
    Dim i, j As Integer
    Dim tabIndexIssue() As String
    If strIssuesValides = "" Then Exit Function
    tabIndexIssue = Split(strIssuesValides, " ")
    For j = 0 To UBound(tabIndexIssue)
        For i = 0 To Me.NbIssues - 1
            If cIssues(i).EstAttribuee = True And cIssues(i).EstEffacee = False Then
                If cIssues(i).IndexGeneral = CInt(tabIndexIssue(j)) Then
                    LieuxOntIssueEnCommun = True
                    Exit Function
                End If
            End If
        Next
    Next
End Function


Public Function IssuesValidesEnChaineSeparateurEspace() As String
    Dim i As Integer
    Dim str As String
    For i = 0 To NbIssues - 1
        If cIssues(i).EstAttribuee = True And cIssues(i).EstEffacee = False Then str = str & CStr(cIssues(i).IndexGeneral) & " "
    Next
    IssuesValidesEnChaineSeparateurEspace = Trim(str)
End Function


Public Function IssueCouranteRelatifVersAbsolu()
    ' necessite que cIssueCourante, Left et Top soient dfinis !
    cIssueCourante.X_Absolu = Left + cIssueCourante.X_Relatif
    cIssueCourante.Y_Absolu = Top + cIssueCourante.Y_Relatif
End Function


Public Function IssueCouranteAbsoluVersRelatif()
    ' necessite que cIssueCourante, Left et Top soient dfinis !
    cIssueCourante.X_Relatif = cIssueCourante.X_Absolu - Left
    cIssueCourante.Y_Relatif = cIssueCourante.Y_Absolu - Top
End Function


' --------------------- TRANSITIONS DE TABLEAUX -------------------------

Public Function gTabDevientContourMurageAbsolu()
    gTab.Contour = ContourMurageAbsolu
End Function

