VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "C_Ligne"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Private lCases() As C_Case
Public NblCases As Integer


Public Function PrepareLigne(ByVal Xi As Integer, ByVal Yi As Integer, ByVal Xf As Integer, ByVal Yf As Integer, Optional booCaseInitialeEteinte As Boolean)
    ' Algorithme de BRENSENHAM - Version Semi volue (mieu que la simple, moins bien que la complte)
    Dim dX, dY, i, xInc, yInc, Cumul, X, Y As Integer
    X = Xi
    Y = Yi
    
    dX = Xf - Xi
    dY = Yf - Yi
    xInc = IIf(dX > 0, 1, -1)
    yInc = IIf(dY > 0, 1, -1)
    dX = Abs(dX)
    dY = Abs(dY)
    
    ReDim lCases(0)
    NblCases = 0
    
    If booCaseInitialeEteinte <> True Then Call AjouteCase(X, Y)      ' Allume CASE INITIALE - A_FAIRE : sera inutile avec un personnage
    If dX > dY Then
        Cumul = dX / 2
        For i = 1 To dX
            X = X + xInc
            Cumul = Cumul + dY
            If Cumul >= dX Then
                Cumul = Cumul - dX
                Y = Y + yInc
            End If
            Call AjouteCase(X, Y)
        Next
    Else
        Cumul = dY / 2
        For i = 1 To dY
            Y = Y + yInc
            Cumul = Cumul + dX
            If Cumul > dY Then
                Cumul = Cumul - dY
                X = X + xInc
            End If
            Call AjouteCase(X, Y)
        Next
    End If
    Call AjouteCase(Xf, Yf) ' Allume CASE FINALE
End Function

Public Function RafraichirLigne(ByVal X_Translate As Integer, ByVal Y_Translate As Integer, ByVal X_Mat As Integer, ByVal Y_Mat As Integer)
    Call cLigne.EffaceLigne
    Call cLigne.PrepareLigne(X_Translate, Y_Translate, X_Mat, Y_Mat)
    Call cLigne.PrepareLigne(X_Mat, Y_Mat, X_Translate, Y_Translate)    ' Fait de mme dans l'autre sens pour trouver toutes les possibilits :
    Call cLigne.AfficheLigne
    Call cLigne.AfficheLigne(, , True)
End Function


Function AjouteCase(ByVal X As Integer, ByVal Y As Integer)
    NblCases = NblCases + 1
    ReDim Preserve lCases(NblCases)
    Set lCases(NblCases - 1) = New C_Case
    lCases(NblCases - 1).X = X
    lCases(NblCases - 1).Y = Y
    lCases(NblCases - 1).EstSurlignee = False
    lCases(NblCases - 1).EstAllumee = False
End Function

Public Function GetCaseSelonIndex(Index As Integer) As C_Case
    Set GetCaseSelonIndex = lCases(Index)
End Function

Function AfficheLigne(Optional ByVal X_Translate As Integer, Optional ByVal Y_Translate As Integer, Optional booConcentrique As Boolean)
    On Error Resume Next
    Dim i, IndexImage As Integer
    Dim cCase As C_Case
    Dim Depart, Arrivee, Increment As Integer
    If booConcentrique = True Then
        Depart = NblCases - 1
        Arrivee = NblCases / 2
        Increment = -1
    Else
        Depart = 0
        Arrivee = NblCases / 2 - 1
        Increment = 1
    End If
    
    For i = Depart To Arrivee Step Increment
        If lCases(i).EstSurlignee = False Then
            Set cCase = cMatrice.CaseSelonCoordonnees(lCases(i).X + X_Translate, lCases(i).Y + Y_Translate)
            ' Si la ligne a rencontr un obstacle opaque, elle n'est pas poursuivie :
            If cCase.cFond.EstOpaque = True Then Exit Function ' A_FAIRE : si on veut tirer sur les murs ceci doit etre mis en fin de boucle
            If Not (cCase Is Nothing) Then
                IndexImage = cCase.IndexImage
                cVariables.frmPrincipale.ImgTile(IndexImage).Appearance = 1
                cVariables.frmPrincipale.ImgTile(IndexImage).BorderStyle = 1
                lCases(i).EstSurlignee = True
            End If
        End If
    Next
End Function


Function EffaceLigne(Optional ByVal X_Translate As Integer, Optional ByVal Y_Translate As Integer)
    Dim i, IndexImage As Integer
    Dim cCase As C_Case
    For i = 0 To NblCases - 1
        If lCases(i).EstSurlignee = True Then
            Set cCase = cMatrice.CaseSelonCoordonnees(lCases(i).X + X_Translate, lCases(i).Y + Y_Translate)
            If Not (cCase Is Nothing) Then
                IndexImage = cCase.IndexImage
                cVariables.frmPrincipale.ImgTile(IndexImage).Appearance = 0
                cVariables.frmPrincipale.ImgTile(IndexImage).BorderStyle = 0
                lCases(i).EstSurlignee = False
            End If
        End If
    Next
    ReDim lCases(0)
    NblCases = 0
End Function


Function AfficheLigneVision(Optional ByVal X_Translate As Integer, Optional ByVal Y_Translate As Integer, Optional booConcentrique As Boolean)
    On Error Resume Next
    Dim i, IndexImage As Integer
    Dim cCase As C_Case
    Dim Depart, Arrivee, Increment As Integer
    If booConcentrique = True Then
        Depart = NblCases - 1
        Arrivee = 0
        Increment = -1
    Else
        Depart = 0
        Arrivee = NblCases - 1
        Increment = 1
    End If
    For i = Depart To Arrivee Step Increment
        If lCases(i).EstAllumee = False Then
            Set cCase = cMatrice.CaseSelonCoordonnees(lCases(i).X + X_Translate, lCases(i).Y + Y_Translate)
            If Not (cCase Is Nothing) Then
                cCase.DoitEtreEteinte = False
                cCase.AllumerImageFond
            End If
            lCases(i).EstAllumee = True
            cCase.EstVisitee = True
            ' Si la ligne a rencontr un obstacle opaque, elle n'est pas poursuivie :
            If cCase.cFond.EstOpaque = True Then Exit Function
        End If
    Next
End Function


Function EffaceLigneVision(Optional ByVal X_Translate As Integer, Optional ByVal Y_Translate As Integer)
    Dim i, IndexImage As Integer
    Dim cCase As C_Case
    For i = 0 To NblCases - 1
        If lCases(i).EstAllumee = True Then
            Set cCase = cMatrice.CaseSelonCoordonnees(lCases(i).X + X_Translate, lCases(i).Y + Y_Translate)
            If Not (cCase Is Nothing) Then cCase.EteindreImageFond
            lCases(i).EstAllumee = False
        End If
    Next
End Function

Function MarqueLigneDoitEtreEteinte(Optional ByVal X_Translate As Integer, Optional ByVal Y_Translate As Integer)
    Dim i As Integer
    Dim cCase As C_Case
    For i = 0 To NblCases - 1
        Set cCase = cMatrice.CaseSelonCoordonnees(lCases(i).X + X_Translate, lCases(i).Y + Y_Translate)
        If Not (cCase Is Nothing) Then cCase.DoitEtreEteinte = True
    Next
End Function

Function EffaceLigneVisionPrecedente(Optional ByVal X_Translate As Integer, Optional ByVal Y_Translate As Integer)
    Dim i, IndexImage As Integer
    Dim cCase As C_Case
    For i = 0 To NblCases - 1
     '   If lCases(i).EstAllumee = True Then
            Set cCase = cMatrice.CaseSelonCoordonnees(lCases(i).X + X_Translate, lCases(i).Y + Y_Translate)
            If Not (cCase Is Nothing) Then
                If cCase.DoitEtreEteinte = True Then
                    cCase.EteindreImageFond
                    cCase.DoitEtreEteinte = False
                    lCases(i).EstAllumee = False
                End If
            End If
            lCases(i).EstAllumee = False
     '   End If
    Next
End Function

