VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "C_Matrice"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private cCases() As New C_Case  ' Non autoris en public, faire une fontion qui le retourne (si possible)

' Dimensions de la matrice en nombres de cases
Public NbCasesX As Long
Public NbCasesY As Long
Public NbCases As Long ' nombre total de cases


Public Sub ChargerDepuisBase()
    Dim cCase As C_Case ' objet temporaire pour amliorer la lisibilit
    Dim IdCase As Integer
    Dim rs As New ADODB.Recordset
    Dim sql As String
    
    Call Me.InitialiserCasesMax
    ReDim cCases(NbCasesX, NbCasesY)
    
    sql = "SELECT * FROM R_CarteGlobale ORDER BY CAR_X, CAR_Y"
    rs.Open sql, cVariables.dbConn, adOpenDynamic
    Do While Not rs.EOF
        Set cCase = New C_Case
        
        ' Chargement des infos gnrales de la case
        Call cCase.Initialiser(Me)
        cCase.IdBase = rs("CAR_Id_CAR")
        cCase.X = rs("CAR_X")
        cCase.Y = rs("CAR_Y")
        
        ' Chargement des infos relatives au fond
        If Not (IsNull(rs("CAR_Id_FON")) Or rs("CAR_Id_FON") = 0) Then
            cCase.ExisteFond = True
            Set cCase.cFond = cElement.FondSelonIdBase(rs("CAR_Id_FON"))
        End If
        
        ' Chargement des infos relatives au dcors
        If Not (IsNull(rs("CAR_Id_DEC")) Or rs("CAR_Id_DEC") = 0) Then
            cCase.ExisteDecor = True
            Set cCase.cDecor = cElement.DecorSelonIdBase(rs("CAR_Id_DEC"))
        End If

        ' Mis ici pour l'instant :
        cCase.DessinerCase
        
        ' Affectation de l'objet temporaire dans l'objet rel
        Set cCases(cCase.X, cCase.Y) = cCase
        
        Set cCase = Nothing
        IdCase = IdCase + 1
        rs.MoveNext
    Loop
    rs.Close
    Set rs = Nothing
    
End Sub


Public Sub ChargerDepuisCartographe()
    Erase cCases
    Call Me.DessinsCasesEffacer
    
    Call cCartographe.CreerCarte
    
    Me.NbCases = cCartographe.NbCases
    Me.NbCasesX = cCartographe.NbCasesX
    Me.NbCasesY = cCartographe.NbCasesY
    
    With cVariables
        .pConteneur.Width = .frmPrincipale.Width / 17
        .pConteneur.Height = .frmPrincipale.Height / 17
        .pConteneur.Left = 2
        .pConteneur.Top = 2
        .pMatrice.Width = (Me.NbCasesX + 1) * .Pas
        .pMatrice.Height = (Me.NbCasesY + 1) * .Pas
        .pMatrice.Left = .pConteneur.Left + (.pConteneur.Width - .pMatrice.Width) / 2
        .pMatrice.Top = .pConteneur.Top + (.pConteneur.Height - .pMatrice.Height) / 2
        .iMasque.Width = .pMatrice.Width
        .iMasque.Height = .pMatrice.Height
        .iMasque.Left = 0
        .iMasque.Top = 0
       ' .iMasque.ZOrder 0
    End With
    
    Call cCartographe.PlacerJoueur
    Call cCartographe.PlacerIndividu(1) ' TEMPORAIRE
    ' A_FAIRE : inclure le placement joueur au cartographe et le faire avant les individus
    cCartographe.gTabDevientCases
    cCases = gTab.cCases

    Call cFonctions.Scrolling
    Call Me.DessinerCases
    Call cJoueur.DessinerImage
    Call cIndividus(1).DessinerImage

    cVariables.iMasque.ZOrder 0


    Call cVision.CreerVision
    Call cVision.RafraichirChamp(cJoueur.X, cJoueur.Y)
   ' Call cVision.AllumerChamp(cJoueur.X, cJoueur.Y)
End Sub


Public Function DessinsCasesEffacer()
    Dim i, nbImages As Long
    nbImages = cVariables.frmPrincipale.ImgTile.Count
    For i = 1 To nbImages - 1
        Unload cVariables.frmPrincipale.ImgTile(i)
    Next
    nbImages = cVariables.frmPrincipale.ImgPersonnage.Count
    For i = 1 To nbImages - 1
        Unload cVariables.frmPrincipale.ImgPersonnage(i)
    Next
End Function


Public Function DessinerCases()
    Dim X, Y As Integer
    For Y = 0 To NbCasesY
        For X = 0 To NbCasesX
            cCases(X, Y).SetEstFranchissable
            cCases(X, Y).DessinerCase
        Next
    Next
End Function


Public Sub InitialiserCasesMax()
    NbCasesX = cFonctions.EnregistrementMax("CAR_Carte", "CAR_X") + 1
    NbCasesY = cFonctions.EnregistrementMax("CAR_Carte", "CAR_Y") + 1
    NbCases = NbCasesX * NbCasesY
End Sub


Public Function CaseSelonCoordonnees(ByVal X As Integer, ByVal Y As Integer) As C_Case
    If X > NbCasesX - 1 Or Y > NbCasesY - 1 Or X < 0 Or Y < 0 Then Exit Function
    Set CaseSelonCoordonnees = cCases(X, Y)
End Function



' -------------- AFFECTATION TABLEAUX GLOBAUX -----------------------

Public Function gTabDevientCases()
    gTab.cCases = cCases
End Function

Public Function gTabAffecteCases()
    cCases = gTab.cCases
End Function
